<?php

namespace MiniFranske\InlineFalTest\Tests\Unit\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \MiniFranske\InlineFalTest\Domain\Model\Main.
 *
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class MainTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {
	/**
	 * @var \MiniFranske\InlineFalTest\Domain\Model\Main
	 */
	protected $subject = NULL;

	protected function setUp() {
		$this->subject = new \MiniFranske\InlineFalTest\Domain\Model\Main();
	}

	protected function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getChildrenReturnsInitialValueForChild() {
		$newObjectStorage = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$this->assertEquals(
			$newObjectStorage,
			$this->subject->getChildren()
		);
	}

	/**
	 * @test
	 */
	public function setChildrenForObjectStorageContainingChildSetsChildren() {
		$child = new \MiniFranske\InlineFalTest\Domain\Model\Child();
		$objectStorageHoldingExactlyOneChildren = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
		$objectStorageHoldingExactlyOneChildren->attach($child);
		$this->subject->setChildren($objectStorageHoldingExactlyOneChildren);

		$this->assertAttributeEquals(
			$objectStorageHoldingExactlyOneChildren,
			'children',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function addChildToObjectStorageHoldingChildren() {
		$child = new \MiniFranske\InlineFalTest\Domain\Model\Child();
		$childrenObjectStorageMock = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array('attach'), array(), '', FALSE);
		$childrenObjectStorageMock->expects($this->once())->method('attach')->with($this->equalTo($child));
		$this->inject($this->subject, 'children', $childrenObjectStorageMock);

		$this->subject->addChild($child);
	}

	/**
	 * @test
	 */
	public function removeChildFromObjectStorageHoldingChildren() {
		$child = new \MiniFranske\InlineFalTest\Domain\Model\Child();
		$childrenObjectStorageMock = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array('detach'), array(), '', FALSE);
		$childrenObjectStorageMock->expects($this->once())->method('detach')->with($this->equalTo($child));
		$this->inject($this->subject, 'children', $childrenObjectStorageMock);

		$this->subject->removeChild($child);

	}
}
